// The code for this widget is cobbled together from a few samples 
// found on Apple's Developer Connection website. In particular, 
// for info on acquiring and parsing an XML feed (this widget uses 
// two of them):
//
//   http://developer.apple.com/internet/webcontent/xmlhttpreq.html
//
// For how to implement scrolling in a, ah, less unattractive style 
// than scrollbars on an iframe:
//
//   http://developer.apple.com/samplecode/Scroller/Scroller.html
// 
// If you have Developer Tools installed (and really, who else would 
// be nosing around in here?) you can also find this file at
//
//   /Developer/Examples/Dashboard/Sample Code/Scroller/
//
// That Stretcher widget gives me some ideas for Version 2!
//
// Finally, while it's not the only way I tested this widget during 
// development, Widgetarium proved to be a valuable means of both 
// testing and also decomposing existing widgets to find out what 
// makes them tick. Not bad for a "beta" release. Find out more at 
//
//    http://projects.gandreas.com/widgetarium/
//
// Copy as much or as little of this as you want, but if you do 
// something cool based on this in any way, consider letting us 
// know about it: software@do-boy.com
//
// Thanks for trying the BPotD widget.
//
// No  2005 Do-Boy Software, use/distribute freely.

var req = new XMLHttpRequest();
var req_desc = new XMLHttpRequest();
var url = "http://www.ubcbotanicalgarden.org/potd/image_feed.xml";
var url_desc = "http://www.ubcbotanicalgarden.org/potd/index.xml";
var defaultCopy = "If you see this, you are not connected to the internet. The Botany Photo of the Day loads directly from the UBC Botanical Garden's website and requires an active internet connection. If you believe you <i>are</i> connected, you can try to <a href=\"javascript:setup()\">reload this widget.</a><br /><br />If you still can't connect to the internet, for now please enjoy a look at <em>Lupinus texensis</em> or the Texas Bluebonnet. Named for its color and, it is said, the resemblance of its petal to a woman's sunbonnet, the bluebonnet is the state flower of Texas.<br /><br />(Pearl appears courtesy of Built By Robots.)";

function setup() {
	// put your setup code here...
	var totd_div = document.getElementById("totd");
	calculateAndShowThumb(totd_div);

	getXML_desc();
	getXML();

	// hack to prevent double-loading each feed
	setTimeout("widget.onshow = setup;",2000);
}

function getXML()
{
	req.onreadystatechange = processReqChange;
	req.open("GET",url,true);
	var d = new Date();// does this even work?
	req.setRequestHeader('If-Modified-Since', d);
	req.send(null);
}
function getXML_desc()
{
	req_desc.onreadystatechange = processReqChange_desc;
	req_desc.open("GET",url_desc,true);
	var d = new Date();// ?
	req_desc.setRequestHeader('If-Modified-Since', d);
	req_desc.send(null);
}

function setCopy(s)
{
	var totd_div = document.getElementById("totd");
	totd_div.innerHTML = s;
	calculateAndShowThumb(totd_div);
}

function processReqChange() {
	// only if req shows "loaded"
	// this method acquires image, title, and page link
	if (req.readyState == 4) {

		// only if "OK"
		if (req.status == 200) {
			// processing statements
			var items = req.responseXML.getElementsByTagName("item");
			
			var title = getElementTextNS("", "title", items[0], 0);
			if ( title.length > 32 ) title = title.substring(0,28) + "...";
			var link_url = getElementTextNS("", "link", items[0], 0);

			var imgsrc = getElementTextNS("", "description", items[0], 0);
			imgsrc = imgsrc.replace(/width="\d+"/, "width=\"180\"");
			imgsrc = imgsrc.replace(/height="\d+"/, "");

			var link =	"<a href=\"" + link_url + "?src=widget\" onClick=\"widget.openURL(this.href);hidePrefs();return false\" title=\"[click for close-up]\">";
			var image_tag = link + imgsrc + "</a>";

			var title_div = document.getElementById("title");
			title_div.innerHTML = link + title + "</a>";

			document.getElementById("potd").innerHTML = link + imgsrc + "</a>";
			document.getElementById("back_pic").innerHTML = link + imgsrc + "</a>";
		} else {
			// nothing to do if it's not ready
		}
	}
}


function processReqChange_desc() {
	// only if req shows "loaded"
	// this method only acquires description (this feed could also provide title and link)
	if (req_desc.readyState == 4) {
		// only if "OK"
		if (req_desc.status == 200) {
			// ...processing statements go here...
			var items = req_desc.responseXML.getElementsByTagName("item");

			var outcopy = getElementTextNS("", "description", items[0], 0);
			var link = getElementTextNS("", "link", items[0], 0);
			link =	"<a href=\"" + link + "?src=widget\" onClick=\"widget.openURL(this.href);hidePrefs();return false\">";

			var totd_div = document.getElementById("totd");
			outcopy = outcopy.replace(/(<a href=[^>]+)(>)/gi,"$1 onClick=\"widget.openURL(this.href);hidePrefs();return false\"$2");// + "... " + link + "[cont'd]</a>";
			outcopy = outcopy + "<p>" + link + "Visit site for close-up photo.</a></p>";
			setCopy(outcopy);

		} else {
			// did not acquire current feed
			setCopy(defaultCopy);
		}
	}
	else
	{
		setCopy("<h3>Loading...</h3>");
	}
	
}

// retrieve text of an XML document element, including
// elements using namespaces
function getElementTextNS(prefix, local, parentElem, index) {
	var result = "";
	// the namespace versions of this method 
	// (getElementsByTagNameNS()) operate
	// differently in Safari and Mozilla, but both
	// return value with just local name, provided 
	// there aren't conflicts with non-namespace element
	// names
	result = parentElem.getElementsByTagName(local)[index];
	if (result)
	{
		// get text, accounting for possible
		// whitespace (carriage return) text nodes 
		if (result.childNodes.length > 1)
		{
			return result.childNodes[1].nodeValue;
		} else {
			return result.firstChild.nodeValue;			
		}
	} else {
		return "n/a";
	}
}

// everything below here handles showing and flipping to the prefs on the back and back again...
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
	widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	document.getElementById("donePrefsButton").display = "block";

	if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
	widget.prepareForTransition("ToFront");

	back.style.display="none";
	document.getElementById("donePrefsButton").display = "none";
	front.style.display="block";

	if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
	if (!flipShown)
	{
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 1.0;
	animate();
	flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
	// fade in the info button
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 0.0;
	animate();
	flipShown = false;
	}
}
function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
	clearInterval (animation.timer);
	animation.timer = null;
	animation.now = animation.to;
	}
	else
	{
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
	animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}
